function report_crm_task(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportCrmTaskWidget = reporting.Base.extend({
        template:'ReportCrmTask',
        content:[],
        rowsData :[],
        modules:['crm','eiru_crm'],
        events:{
            'click #toolbar > button' : 'clickOnAction',

            'click #generate' : 'fetchGenerate',
            'click-row.bs.table #table ' : 'clickAnalysisDetail',
        },
        init : function(parent){
            this._super(parent);
        },
        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.fecthFecha();
            this.fetchInitial();
        },


        // Redirecionar
        renderReport: function () {
            var self = this;

            var container = this.$el.closest('.oe_form_sheet.oe_form_sheet_width');
            this.$el.closest('.report_view').remove();
            container.find('.report_view').show({
                effect: 'fade',
                duration: 200,
            });
        },
        // Verificar el modelo
        checkModel : function(model){
            var self = this;
            return _.filter(self.modules,function(item){return item.name === model});
        },
        // Lanzar el mensaje
        showMensaje : function(modelos){
            var self = this;
            $("#dialog" ).dialog({
                autoOpen: true,
                resizable: false,
                modal: true,
                title: 'Atención',
                width: 500,
                open: function() {
                    $(this).html('Reporte in-disponible, contacte con el administrador del sistema ref : '+modelos);
                },
                show: {
                    effect: "fade",
                    duration: 200
                },
                hide: {
                    effect: "fade",
                    duration: 200
                },
                buttons: {
                    Aceptar: function() {
                        $(this).dialog('close');
                        self.renderReport()
                    }
                }
            });
            return
        },

        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },

        clickAnalysisDetail: function(e, row, $element, field){
            if (field == 'partner'){
                 this.do_action({
                     name:"Registro de Cliente",
                     type: 'ir.actions.act_window',
                     res_model: "res.partner",
                     views: [[false,'form']],
                     target: 'new',
                     domain: [['id','=', row.partner_id]],
                     context: {},
                     flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                     res_id: row.partner_id,
                 });
            }
            if (field === 'activity'){
                this.do_action({
                    name:"Registro de Tareas",
                    type: 'ir.actions.act_window',
                    res_model: "crm.task",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.id,
                });
            }

             e.stopImmediatePropagation();
        },

        fetchInitial: function () {
            var self = this;
            self.fecthIrModuleModule().then(function (IrModuleModule) {
                return IrModuleModule;
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
                return self.fetchResUser();
            }).then(function (ResUser) {
                self.ResUser = ResUser;
                if(ResUser.length > 1){
                    self.$el.find('#current-user').append('<option value="9999999">Todos los usuarios</option>');
                    _.each(ResUser,function(item){
                        self.$el.find('#current-user').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.user').css('display','none');
                }
                self.fecthCheckType();
                return self.fetchResPartner();
            }).then(function(ResPartner){
                self.ResPartner = ResPartner;
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });

            this.fetchCrmTask().then(function(ResCrmTask) {
                return ResCrmTask;
            }).then(function (ResCrmTask) {
                self.ResCrmTask = ResCrmTask;
                return self.fetchTaskType();
            }).then(function (TaskType) {
                self.TaskType = TaskType;
                if(TaskType.length > 1){
                    self.$el.find('#current-type').append('<option value="9999999">Todos los medios</option>');
                    _.each(TaskType,function(item){
                        self.$el.find('#current-type').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.currenttype').css('display','none');
                }
                return self.fetchCrm();
            }).then(function (ResCrm) {
                self.ResCrm = ResCrm;
                return self.BuildTable();
            });
        },

        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
            from = $( "#from" )
            .datepicker({
                dateFormat: "dd/mm/yy",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
            });
            to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
            });
            function getDate( element ) {
                var fechaSel =element.value.split('/');
                var date;
                try {
                    date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                } catch( error ) {
                    date = null;
                }
                return date;
            }
        },

        fecthIrModuleModule: function(){
             var self = this;
             var defer = $.Deferred();
             var fields = ['name','id'];
             var domain=[['state','=','installed'],['name','in',self.modules]];
             var IrModuleModule = new model.web.Model('ir.module.module');
             IrModuleModule.query(fields).filter(domain).all().then(function(results){
                 defer.resolve(results);
             })
             return defer;
        },

         /*=====================================================================
             Check type
         =====================================================================*/
         fecthCheckType: function(){
             var self = this;
             var modules = self.checkModel('eiru_crm');
             if(modules.length == 0){
                 self.$el.find('.type').css('display','none');
             }
        },

         /*=====================================================================
             USER
         =====================================================================*/
         fetchResUser: function() {
             var self = this;
             var defer = $.Deferred();
             var fields = ['id','name','store_id'];
             var ResUser = new model.web.Model('res.users');
             ResUser.query(fields).filter().all().then(function (results) {
                 defer.resolve(results);
             });
             return defer;
         },

         /*====================================================================
             CRM TASK
         ====================================================================*/
         fetchCrmTask: function() {
             var self = this;
             var defer = $.Deferred();
             var stage_ids = _.flatten(_.map(self.TaskType, function (item) {
                 return item.id;
             }));
             var state = self.$el.find('#current-state').val();
             var currenttype = self.$el.find('#current-type').val();
             var desde = self.$el.find('#from').val();
             var hasta = self.$el.find('#to').val();
             var domain = [['active', '=', true]];
             if(state != 9999999){
                 domain.push(['state','=',state]);
             }
             if(currenttype && currenttype != 9999999){
                 domain.push(['task_type_id','=',parseInt(currenttype)]);
             }
             if(desde){
                 var date = desde.split('/')
                 date = (date[2]+"-"+date[1]+"-"+date[0])
                 domain.push(['create_date','>',date]);
             }
             if(hasta){
                 var date = hasta.split('/')
                 date = (date[2]+"-"+date[1]+"-"+date[0])
                 domain.push(['create_date','<',date]);
             }
             var fields = [
                 'id',
                 'partner_id',
                 'name',
                 'description',
                 'create_date',
                 'user_id',
                 'task_type_id',
                 'opportunity_id',
                 'state',
                 'date_action_next',
             ];
             var ResCrmTask = new model.web.Model('crm.task');
             ResCrmTask.query(fields).filter(domain).all().then(function (results) {
                 defer.resolve(results);
             });
             return defer;
        },

        fetchTaskType: function () {
            var self = this;
            var defer = $.Deferred();

            var TaskType = new model.web.Model('crm.task.type');
            TaskType.query(['id', 'name']).filter([['active', '=', true]]).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        fetchCrm: function () {
            var self = this;
            var defer = $.Deferred();

            var ResCrm = new model.web.Model('crm.lead');
            ResCrm.query(['id', 'partner_id', 'name', 'description', 'create_date', 'user_id', 'stage_id', 'type']).filter([['active', '=', true]]).all().then(function(results){
                defer.resolve(results);
            });

            return defer;
        },

        fetchResPartner: function () {
            var self = this;
            var defer = $.Deferred();
            var ResPartner = new model.web.Model('res.partner');
            ResPartner.query(['id','name','ruc']).filter([['active', '=', true]]).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        getCrm: function (id) {
            var self = this;
            return _.filter(self.ResCrm,function (item) {
                return item.opportunity_id == id;
            });
        },

        getCrmTask: function (id) {
            var self = this;
            return _.filter(self.ResCrmTask,function (item) {
                return item.id == id;
            });
        },

        BuildTable: function(){
            var self = this;
            var data = [];
            var Crm;
            var taskType;
            var stage;
            var crmtask = self.ResCrmTask;
            _.each(crmtask, function(item){

                if(item.state=='pending'){
                    stage = 'Pendiente'
                }else{
                    if(item.state=='done'){
                        stage = 'Realizado'
                    }else{
                        stage = 'Cancelado'
                    }
                }

                // taskType = self.getCrmTask(item.id).shift();
                // Crm = self.getCrm(item.id);

                data.push({
                    id : item.id,
                    opportunity_id : self.valorNull(item.opportunity_id),
                    partner: self.valorNull(item.partner_id[1]),
                    description: self.valorNull(item.description),
                    activity: self.valorNull(item.name),
                    create_date: moment(item.create_date).format("DD/MM/YYYY"),
                    date: moment(item.create_date).format("YYYY-MM-DD"),
                    user: item.user_id[1],
                    task_type_id: item.task_type_id[0],
                    next_date: moment(item.date_action_next).format("DD/MM/YYYY"),
                    task_name:  item.task_type_id[1],
                    stage: stage,
                    partner_id : item.partner_id[0],
                });
            });
            self.content = data;
            self.loadTable(data);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },

        clickOnAction: function (e) {
            var self = this;
            var action = self.$el.find(e.target).val();
            var getColumns=[];
            var rows=[];
            var table = self.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');
            if (action === 'pdf') {
                 var data = _.map(column, function (val){return val.field});
                 _.each(row,function (item){
                     rows.push(_.pick(item, data));
                 });
                 // Obtener los nombre de la Cabecera
                 _.each(_.map(column,function(val){
                        return val}), function(item){
                        getColumns.push([{
                            title: item.title,
                            dataKey: item.field
                        }]);
                 });
                 this.drawPDF(_.flatten(getColumns),rows)
             }
        },

        drawPDF: function (getColumns,row) {
            var self = this;
            var hoy = moment().format('DD/MM/YYYY');
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF();

            pdfDoc.autoTable(getColumns, row, {
                showHeader: 'firstPage',
                theme: 'grid',
                styles: {
                    overflow: 'linebreak',
                    fontSize: 7,
                    columnWidth: 'wrap',
                },
                headerStyles: {
                    fillColor: [76, 133, 248],
                    fontSize: 8
                },

                columnStyles: {
                  create_date : {columnWidth: '8px'},
                  partner : {columnWidth: '8px'},
                  activity : {columnWidth: '8px'},
                  user : {columnWidth: '8px'},
                  description : {columnWidth: '8px'},
                  task_name: {columnWidth: '8px'},
                  stage : {columnWidth: '8px'},
                },
                margin: { top: 20, horizontal: 7},

                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Histórico de Tareas CRM', data.settings.margin.left, 10);


                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40)
                    // pdfDoc.text(6,14,tipo);

                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(175,pdfDoc.internal.pageSize.height - 5,str);
                }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            row.pop();
            pdfDoc.save('Histórico de Tareas CRM.pdf')
        },
    });
}
